/*
 * dmatrix.c
 */

#include <stdlib.h>
#include <quadmath.h>
#include "matrix.h"

matrix128 new_matrix128(int nrow, int ncol)
{
    int i;
    vector128 ap;
    matrix128 a;

    if ((a = malloc(nrow * sizeof(vector128))) == NULL)
	    return NULL;
    if ((ap = malloc(nrow * ncol * sizeof(__float128))) == NULL) {
	free(a);
	return NULL;
    }
    for (i = 0; i < nrow; i++)
        a[i] = ap + (i * ncol);
    return a;
}

void free_matrix128(matrix128 a)
{
    free(a[0]);
    free(a);
}
